require "sources.common"
local monarch = require "monarch.monarch"

local M = {}

function M.initialize(settings)
	M.CELL_HEIGHT = settings.cell_height
	M.CELL_WIDTH = settings.cell_width
	M.OFFSET_X = 0
	M.OFFSET_Y = 0
	M.OFFSET_MIN_X = 0
	M.OFFSET_MIN_Y = 0
	M.OFFSET_MAX_X = 0
	M.OFFSET_MAX_Y = 0
end

function M.generate(map_width, map_height)
	M.field = {}
	M.MAP_HEIGHT = map_height
	M.MAP_WIDTH = map_width

	for y = 1, M.MAP_HEIGHT do
		M.field[y] = {}
		for x = 1, M.MAP_WIDTH do
			M.field[y][x] = {}
			M.field[y][x].x = x
			M.field[y][x].y = y

			local sx = ((x-1) - (M.MAP_WIDTH-1)/2 - 1/4 + ((y%2==0) and 0.5 or 0))*M.CELL_WIDTH
			local sy = ((M.MAP_HEIGHT-1)/2 - (y-1))*M.CELL_HEIGHT/2
			M.field[y][x].sx = sx
			M.field[y][x].sy = sy

			local texture = math.random(#TEXTURES)
			local height = math.random()/10
			if texture==8 then height = 0 end
			local mesh_cell = factory.create("map:/MAP_3D#cells", v3(sx, height-0.5, sy))
			local mesh_url = msg.url(nil, mesh_cell, "mesh")
			go.set(mesh_url, "texture0", TEXTURES[texture])

			if texture~=8 then
				local rotation = vmath.quat_rotation_y(math.rad(math.random()*180))
				local position = v3(sx+(math.random()-0.5)/2, height, sy+(math.random()-0.5)/2)
				local mesh_house = factory.create("map:/MAP_3D#buildings", position, rotation, nil, 1/20)
			end
		end
	end
end

return M